Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 224845)
+++ channels/chan_sip.c	(working copy)
@@ -14268,6 +14268,14 @@
 		ast_verbose("Found peer '%s' for '%s' from %s:%d\n",
 			peer->name, of, ast_inet_ntoa(p->recv.sin_addr), ntohs(p->recv.sin_port));
 
+	if (!(peer && ast_apply_ha(peer->ha, sin))) {
+		/* Peer fails ACL check */
+		unref_peer(peer, "register_verify: unref_peer: from find_peer operation");
+		peer = NULL;
+		return AUTH_ACL_FAILED;
+	}
+		
+			
 	/* XXX what about p->prefs = peer->prefs; ? */
 	/* Set Frame packetization */
 	if (p->rtp) {
